export interface Response {
    code?: string;
    success: boolean;
    message?: string;
    data?: any;
}
interface FormRelated {
    submit<T>(url?: string, data?: T): Promise<Response>;
    getOptionsByUrl<T>(url?: string, data?: T): Promise<Response>;
}
declare class FormRelatedStore implements FormRelated {
    submit<T>(url?: string, data?: T): Promise<Response>;
    getOptionsByUrl<T>(url?: string, data?: T): Promise<Response>;
}
declare const _default: FormRelatedStore;
export default _default;
