"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _antd = require("antd");
var _CloseOutlined = _interopRequireDefault(require("@ant-design/icons/lib/icons/CloseOutlined"));
var _SearchOutlined = _interopRequireDefault(require("@ant-design/icons/lib/icons/SearchOutlined"));
var _icons = require("@ant-design/icons");
var _classnames = _interopRequireDefault(require("classnames"));
var _lodash = require("lodash");
require("./index.less");
var _treeNode = _interopRequireDefault(require("../tree-node"));
var _shard = require("./shard");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return exports; }; var exports = {}, Op = Object.prototype, hasOwn = Op.hasOwnProperty, defineProperty = Object.defineProperty || function (obj, key, desc) { obj[key] = desc.value; }, $Symbol = "function" == typeof Symbol ? Symbol : {}, iteratorSymbol = $Symbol.iterator || "@@iterator", asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator", toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag"; function define(obj, key, value) { return Object.defineProperty(obj, key, { value: value, enumerable: !0, configurable: !0, writable: !0 }), obj[key]; } try { define({}, ""); } catch (err) { define = function define(obj, key, value) { return obj[key] = value; }; } function wrap(innerFn, outerFn, self, tryLocsList) { var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator, generator = Object.create(protoGenerator.prototype), context = new Context(tryLocsList || []); return defineProperty(generator, "_invoke", { value: makeInvokeMethod(innerFn, self, context) }), generator; } function tryCatch(fn, obj, arg) { try { return { type: "normal", arg: fn.call(obj, arg) }; } catch (err) { return { type: "throw", arg: err }; } } exports.wrap = wrap; var ContinueSentinel = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var IteratorPrototype = {}; define(IteratorPrototype, iteratorSymbol, function () { return this; }); var getProto = Object.getPrototypeOf, NativeIteratorPrototype = getProto && getProto(getProto(values([]))); NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype); var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype); function defineIteratorMethods(prototype) { ["next", "throw", "return"].forEach(function (method) { define(prototype, method, function (arg) { return this._invoke(method, arg); }); }); } function AsyncIterator(generator, PromiseImpl) { function invoke(method, arg, resolve, reject) { var record = tryCatch(generator[method], generator, arg); if ("throw" !== record.type) { var result = record.arg, value = result.value; return value && "object" == _typeof(value) && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) { invoke("next", value, resolve, reject); }, function (err) { invoke("throw", err, resolve, reject); }) : PromiseImpl.resolve(value).then(function (unwrapped) { result.value = unwrapped, resolve(result); }, function (error) { return invoke("throw", error, resolve, reject); }); } reject(record.arg); } var previousPromise; defineProperty(this, "_invoke", { value: function value(method, arg) { function callInvokeWithMethodAndArg() { return new PromiseImpl(function (resolve, reject) { invoke(method, arg, resolve, reject); }); } return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(innerFn, self, context) { var state = "suspendedStart"; return function (method, arg) { if ("executing" === state) throw new Error("Generator is already running"); if ("completed" === state) { if ("throw" === method) throw arg; return doneResult(); } for (context.method = method, context.arg = arg;;) { var delegate = context.delegate; if (delegate) { var delegateResult = maybeInvokeDelegate(delegate, context); if (delegateResult) { if (delegateResult === ContinueSentinel) continue; return delegateResult; } } if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) { if ("suspendedStart" === state) throw state = "completed", context.arg; context.dispatchException(context.arg); } else "return" === context.method && context.abrupt("return", context.arg); state = "executing"; var record = tryCatch(innerFn, self, context); if ("normal" === record.type) { if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue; return { value: record.arg, done: context.done }; } "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg); } }; } function maybeInvokeDelegate(delegate, context) { var methodName = context.method, method = delegate.iterator[methodName]; if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel; var record = tryCatch(method, delegate.iterator, context.arg); if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel; var info = record.arg; return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel); } function pushTryEntry(locs) { var entry = { tryLoc: locs[0] }; 1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry); } function resetTryEntry(entry) { var record = entry.completion || {}; record.type = "normal", delete record.arg, entry.completion = record; } function Context(tryLocsList) { this.tryEntries = [{ tryLoc: "root" }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0); } function values(iterable) { if (iterable) { var iteratorMethod = iterable[iteratorSymbol]; if (iteratorMethod) return iteratorMethod.call(iterable); if ("function" == typeof iterable.next) return iterable; if (!isNaN(iterable.length)) { var i = -1, next = function next() { for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next; return next.value = undefined, next.done = !0, next; }; return next.next = next; } } return { next: doneResult }; } function doneResult() { return { value: undefined, done: !0 }; } return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), defineProperty(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) { var ctor = "function" == typeof genFun && genFun.constructor; return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name)); }, exports.mark = function (genFun) { return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun; }, exports.awrap = function (arg) { return { __await: arg }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () { return this; }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) { void 0 === PromiseImpl && (PromiseImpl = Promise); var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl); return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) { return result.done ? result.value : iter.next(); }); }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () { return this; }), define(Gp, "toString", function () { return "[object Generator]"; }), exports.keys = function (val) { var object = Object(val), keys = []; for (var key in object) keys.push(key); return keys.reverse(), function next() { for (; keys.length;) { var key = keys.pop(); if (key in object) return next.value = key, next.done = !1, next; } return next.done = !0, next; }; }, exports.values = values, Context.prototype = { constructor: Context, reset: function reset(skipTempReset) { if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined); }, stop: function stop() { this.done = !0; var rootRecord = this.tryEntries[0].completion; if ("throw" === rootRecord.type) throw rootRecord.arg; return this.rval; }, dispatchException: function dispatchException(exception) { if (this.done) throw exception; var context = this; function handle(loc, caught) { return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught; } for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i], record = entry.completion; if ("root" === entry.tryLoc) return handle("end"); if (entry.tryLoc <= this.prev) { var hasCatch = hasOwn.call(entry, "catchLoc"), hasFinally = hasOwn.call(entry, "finallyLoc"); if (hasCatch && hasFinally) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } else if (hasCatch) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); } else { if (!hasFinally) throw new Error("try statement without catch or finally"); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } } } }, abrupt: function abrupt(type, arg) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) { var finallyEntry = entry; break; } } finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null); var record = finallyEntry ? finallyEntry.completion : {}; return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record); }, complete: function complete(record, afterLoc) { if ("throw" === record.type) throw record.arg; return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel; }, finish: function finish(finallyLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel; } }, catch: function _catch(tryLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc === tryLoc) { var record = entry.completion; if ("throw" === record.type) { var thrown = record.arg; resetTryEntry(entry); } return thrown; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(iterable, resultName, nextLoc) { return this.delegate = { iterator: values(iterable), resultName: resultName, nextLoc: nextLoc }, "next" === this.method && (this.arg = undefined), ContinueSentinel; } }, exports; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var SelectTree = function SelectTree(props) {
  var hasSelectedKeys = props.hasSelectedKeys,
    data = props.data,
    checkable = props.checkable,
    onSelectResult = props.onSelectResult,
    rootId = props.rootId,
    getSearchResultByname = props.getSearchResultByname,
    title = props.title,
    searchPlaceholder = props.searchPlaceholder,
    showClearButton = props.showClearButton,
    listType = props.listType,
    env = props.env;
  var _useState = (0, _react.useState)([]),
    _useState2 = _slicedToArray(_useState, 2),
    selectedKeys = _useState2[0],
    setSelectedKeys = _useState2[1];
  var cacheResultMap = (0, _react.useRef)(new Map());
  var _useState3 = (0, _react.useState)(true),
    _useState4 = _slicedToArray(_useState3, 2),
    visibleTree = _useState4[0],
    setVisibleTree = _useState4[1];
  var _useState5 = (0, _react.useState)([rootId]),
    _useState6 = _slicedToArray(_useState5, 2),
    expandedKeys = _useState6[0],
    setExpandedKeys = _useState6[1];
  var _useState7 = (0, _react.useState)({}),
    _useState8 = _slicedToArray(_useState7, 2),
    employeeOrdepartmentSearchResult = _useState8[0],
    setEmployeeOrdepartmentSearchResult = _useState8[1];
  var dataMapRef = (0, _react.useRef)(new Map());
  // 将选中的结果存入map中
  var addCacheResultByKey = function addCacheResultByKey(node) {
    var id = node.id;
    if (cacheResultMap.current.has(id)) {
      return;
    }
    cacheResultMap.current.set(id, node);
    getSelectedResults();
  };
  // 将未选中的结果从map中移除
  var deleteCacheResultByKey = function deleteCacheResultByKey(key) {
    cacheResultMap.current.delete(key);
    getSelectedResults();
  };
  var deleteOrModify = function deleteOrModify(node) {
    var id = node.id;
    if (!cacheResultMap.current.has(id)) {
      addCacheResultByKey(node);
      return;
    }
    deleteCacheResultByKey(id);
  };
  // 按照输入的名字对部门和人员进行搜索
  var getSearchResult = (0, _react.useCallback)( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(name) {
      var _yield$getSearchResul, data, success, result, departmentList, employeeList;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            if (!(name.length === 0)) {
              _context.next = 2;
              break;
            }
            return _context.abrupt("return");
          case 2:
            _context.next = 4;
            return getSearchResultByname(name, env);
          case 4:
            _yield$getSearchResul = _context.sent;
            data = _yield$getSearchResul.data;
            success = _yield$getSearchResul.success;
            result = {
              departmentList: [],
              employeeList: []
            };
            if (!(!success || data === null)) {
              _context.next = 10;
              break;
            }
            return _context.abrupt("return");
          case 10:
            departmentList = data.departmentList, employeeList = data.employeeList;
            if (departmentList) {
              result.departmentList = (0, _shard.addKeyByArrayMap)(departmentList, false);
            }
            if (employeeList) {
              result.employeeList = (0, _shard.addKeyByArrayMap)(employeeList, true);
            }
            setEmployeeOrdepartmentSearchResult(result);
          case 14:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function (_x2) {
      return _ref.apply(this, arguments);
    };
  }(), [getSearchResultByname]);
  var searchEmployerrOrdepartment = (0, _lodash.debounce)(getSearchResult, 500, {
    maxWait: 500
  });
  // 点击树进行触发选择
  var onSelect = function onSelect(selectedKeysValue, _ref2) {
    var node = _ref2.node;
    // 单选需要清空每一次的数据
    if (listType && !checkable) {
      cacheResultMap.current.clear();
    }
    // 多选是点击一个进行追加
    setSelectedKeys((0, _shard.traverseKeys)(selectedKeysValue, dataMapRef.current));
    deleteOrModify(node);
  };
  // 树展开的状态
  var onExpand = function onExpand(expandedKeysValue) {
    setExpandedKeys(expandedKeysValue);
  };
  var onChange = function onChange(e) {
    var value = e.target.value;
    if (value === '') {
      setVisibleTree(true);
      return;
    }
    searchEmployerrOrdepartment(value);
    setVisibleTree(false);
  };
  var getSelectedResults = function getSelectedResults() {
    var selectResults = Array.from(cacheResultMap.current).map(function (result) {
      return _objectSpread({}, result[1]);
    });
    onSelectResult === null || onSelectResult === void 0 ? void 0 : onSelectResult(selectResults);
  };
  //  选中树前面的checkobox进行触发
  var onCheck = function onCheck(_, _ref3) {
    var checkedNodes = _ref3.checkedNodes,
      node = _ref3.node,
      checked = _ref3.checked;
    var id = node.id;
    // 如果是多选需要选择多个
    var filterCheckedNodes = checkedNodes.filter(function (checkedNode) {
      var key = checkedNode.key;
      return key.indexOf(id) <= 0;
    });
    // 部门组件需要特殊处理不然会导致非叶子节点无法选中
    if (listType === 'deparement') {
      filterCheckedNodes = filterCheckedNodes.map(function (checkedNodes) {
        return _objectSpread(_objectSpread({}, checkedNodes), {}, {
          isLeaf: true
        });
      });
      checkedNodes = checkedNodes.map(function (checkedNodes) {
        return _objectSpread(_objectSpread({}, checkedNodes), {}, {
          isLeaf: true
        });
      });
    }
    var newCheckedNodes = checked ? checkedNodes : filterCheckedNodes;
    var mapCheckedNodes = newCheckedNodes.map(function (item) {
      return item.key;
    });
    cacheResultMap.current = (0, _shard.generateMapfromArray)(newCheckedNodes);
    setSelectedKeys((0, _shard.traverseKeys)(mapCheckedNodes, dataMapRef.current));
    getSelectedResults();
  };
  // 删除列表的人员或者部门
  var deleteEmployerOrDepartmentByKey = function deleteEmployerOrDepartmentByKey(key) {
    var newSelectedKeys = _toConsumableArray(selectedKeys);
    var index = newSelectedKeys.findIndex(function (selected) {
      return selected.indexOf(key) > -1;
    });
    if (index === -1) {
      return;
    }
    deleteCacheResultByKey(key);
    newSelectedKeys.splice(index, 1);
    setSelectedKeys(newSelectedKeys);
  };
  // 添加列表的人员或者员工
  var addEmployerOrDepartment = function addEmployerOrDepartment(node) {
    var key = node.key;
    addCacheResultByKey(node);
    setSelectedKeys([].concat(_toConsumableArray(selectedKeys), [key]));
  };
  var renderIcon = function renderIcon(checked) {
    if (checked === true) {
      return /*#__PURE__*/_react.default.createElement(_icons.CheckOutlined, null);
    }
    return /*#__PURE__*/_react.default.createElement(_CloseOutlined.default, null);
  };
  var filterDataByListType = function filterDataByListType(listType, array) {
    if (!array) {
      return [];
    }
    if (listType === 'deparement') {
      return array.filter(function (employerrOrDepartmentArray) {
        var _employerrOrDepartmen = _slicedToArray(employerrOrDepartmentArray, 2),
          _ = _employerrOrDepartmen[0],
          employerrOrDepartment = _employerrOrDepartmen[1];
        var isEmployee = employerrOrDepartment.isEmployee;
        return !isEmployee;
      });
    }
    if (listType === 'employee') {
      return array.filter(function (employerrOrDepartmentArray) {
        var _employerrOrDepartmen2 = _slicedToArray(employerrOrDepartmentArray, 2),
          _ = _employerrOrDepartmen2[0],
          employerrOrDepartment = _employerrOrDepartmen2[1];
        var isEmployee = employerrOrDepartment.isEmployee;
        return isEmployee;
      });
    }
    return array;
  };
  var renderEmployeeOrdepartment = function renderEmployeeOrdepartment(map) {
    var transformArrayFromMap = Array.from(map);
    transformArrayFromMap = filterDataByListType(listType, transformArrayFromMap);
    return transformArrayFromMap.map(function (employerrOrDepartmentArray) {
      var _employerrOrDepartmen3 = _slicedToArray(employerrOrDepartmentArray, 2),
        key = _employerrOrDepartmen3[0],
        employerrOrDepartment = _employerrOrDepartmen3[1];
      var name = employerrOrDepartment.name,
        isEmployee = employerrOrDepartment.isEmployee;
      var onDelete = function onDelete() {
        deleteEmployerOrDepartmentByKey(key);
      };
      return /*#__PURE__*/_react.default.createElement("div", {
        key: key,
        className: "select-tree-list-item"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "select-tree-list-item-title"
      }, /*#__PURE__*/_react.default.createElement(_treeNode.default, {
        isLeaf: isEmployee
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: "title-wrapper"
      }, /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
        title: name
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "title"
      }, name)))), /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_CloseOutlined.default, {
        className: "closeIcon",
        onClick: onDelete
      })));
    });
  };
  var handleClickEmployeeOrdepartmentSearchItem = function handleClickEmployeeOrdepartmentSearchItem(checked, node) {
    var key = node.key;
    if (checked === true) {
      deleteEmployerOrDepartmentByKey(key);
      return;
    }
    addEmployerOrDepartment(node);
  };
  // 渲染搜索列表
  var renderEmployeeOrdepartmentSearchList = function renderEmployeeOrdepartmentSearchList(list) {
    if (!list) {
      return;
    }
    if (list.length === 0) {
      return /*#__PURE__*/_react.default.createElement(_antd.Empty, {
        image: _antd.Empty.PRESENTED_IMAGE_SIMPLE
      });
    }
    var employOrDepartmentIsChecked = 'employee-or-department-is-checked';
    var className = (0, _classnames.default)(_defineProperty({}, "".concat(employOrDepartmentIsChecked), true));
    var renderRadio = function renderRadio(checkable, checked) {
      if (checkable) {
        return;
      }
      if (checked) {
        return /*#__PURE__*/_react.default.createElement(_antd.Radio.Group, {
          value: 1
        }, /*#__PURE__*/_react.default.createElement(_antd.Radio, {
          value: 1
        }));
      }
      return /*#__PURE__*/_react.default.createElement(_antd.Radio.Group, {
        value: 1
      }, /*#__PURE__*/_react.default.createElement(_antd.Radio, {
        value: 2
      }));
    };
    return list.map(function (employeeOrdepartment) {
      var key = employeeOrdepartment.key,
        name = employeeOrdepartment.name,
        isEmployee = employeeOrdepartment.isEmployee;
      var checked = cacheResultMap.current.has(key);
      var onClick = function onClick() {
        // 修复单选存在选中多项的bug
        if (!checked && !checkable) {
          cacheResultMap.current.clear();
        }
        handleClickEmployeeOrdepartmentSearchItem(checked, employeeOrdepartment);
      };
      return /*#__PURE__*/_react.default.createElement("div", {
        key: key,
        className: className,
        onClick: onClick
      }, renderRadio(checkable, checked), /*#__PURE__*/_react.default.createElement("div", {
        className: "checked-tree-node"
      }, /*#__PURE__*/_react.default.createElement(_treeNode.default, {
        isLeaf: isEmployee,
        name: name
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: "checked-icon"
      }, renderIcon(checked)));
    });
  };
  var employeeList = employeeOrdepartmentSearchResult.employeeList,
    departmentList = employeeOrdepartmentSearchResult.departmentList;
  var renderEmployeeOrDepartmentList = function renderEmployeeOrDepartmentList(listType) {
    var employees = /*#__PURE__*/_react.default.createElement("div", {
      className: "checked"
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "checked-title"
    }, "\u5458\u5DE5\uFF1A"), renderEmployeeOrdepartmentSearchList(employeeList));
    var departments = /*#__PURE__*/_react.default.createElement("div", {
      className: "checked"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "checked-title"
    }, "\u90E8\u95E8\uFF1A"), renderEmployeeOrdepartmentSearchList(departmentList));
    if (listType === 'employee') {
      return employees;
    }
    if (listType === 'deparement') {
      return departments;
    }
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, employees, departments);
  };
  // 渲染树或者渲染列表
  var renderTreeOrList = function renderTreeOrList(visible) {
    if (visible) {
      return /*#__PURE__*/_react.default.createElement(_antd.Tree, {
        treeData: data,
        showIcon: true,
        checkable: checkable,
        height: 375,
        checkStrictly: listType === 'deparement',
        style: {
          overflow: 'auto'
        },
        onExpand: onExpand,
        expandedKeys: expandedKeys,
        checkedKeys: selectedKeys,
        selectedKeys: selectedKeys,
        onSelect: onSelect,
        onCheck: onCheck
      });
    }
    return renderEmployeeOrDepartmentList(listType);
  };
  var transformArrayToMap = function transformArrayToMap(hasSelectedKeys) {
    var map = new Map();
    if (!hasSelectedKeys) {
      return map;
    }
    hasSelectedKeys.forEach(function (hasSelectedKey) {
      var id = hasSelectedKey.id;
      var data = dataMapRef.current.get(id);
      if (!data) return;
      map.set(id, data[0]);
    });
    return map;
  };
  var getSelectedKeys = function getSelectedKeys(hasSelectedKeys) {
    cacheResultMap.current = transformArrayToMap(hasSelectedKeys);
    var newSelectedKeys = hasSelectedKeys.map(function (item) {
      var id = item.id;
      return id;
    });
    setSelectedKeys((0, _shard.traverseKeys)(newSelectedKeys, dataMapRef.current));
  };
  (0, _react.useEffect)(function () {
    // 获取扁平化数据
    var flattenData = (0, _shard.flattenTreeData)(data, []);
    dataMapRef.current = (0, _shard.transformArryToMap)(flattenData);
  }, [data]);
  (0, _react.useEffect)(function () {
    getSelectedKeys(hasSelectedKeys);
  }, [hasSelectedKeys]);
  // 清空
  var clearEmployerOrDepartment = function clearEmployerOrDepartment() {
    clearCacheResult();
    setSelectedKeys([]);
  };
  // map清空
  var clearCacheResult = function clearCacheResult() {
    cacheResultMap.current = new Map([]);
    getSelectedResults();
  };
  var renderClearButton = function renderClearButton(showClearButton) {
    if (showClearButton) {
      return /*#__PURE__*/_react.default.createElement(_antd.Button, {
        className: "select-tree-delect",
        type: "link",
        onClick: clearEmployerOrDepartment
      }, "\u6E05\u7A7A");
    }
    return null;
  };
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "select-tree"
  }, /*#__PURE__*/_react.default.createElement("div", {
    style: {
      overflow: 'auto',
      flex: 1
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "select-tree-input"
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    allowClear: true,
    onChange: onChange,
    prefix: /*#__PURE__*/_react.default.createElement(_SearchOutlined.default, null),
    placeholder: searchPlaceholder
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "select-tree-wrapper"
  }, renderTreeOrList(visibleTree))), /*#__PURE__*/_react.default.createElement("div", {
    className: "select-tree-list-wrapper"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "select-tree-title"
  }, title, renderClearButton(showClearButton)), /*#__PURE__*/_react.default.createElement("div", {
    className: "select-tree-list"
  }, renderEmployeeOrdepartment(cacheResultMap.current))));
};
var _default = SelectTree;
exports.default = _default;