export interface Response {
    status: number;
    data: any;
    statusText: string;
}
export interface AxiosRequestConfig {
    baseURL?: string;
    timeout: number;
    headers?: any;
    url?: string;
}
type Env = 'dev' | 'qa' | 'prod';
declare const httpClient: import("axios").AxiosInstance;
declare function get<T = any>(url?: string | undefined, params?: any, env?: Env): Promise<T>;
declare function post<T = any>(url?: string | undefined, data?: any, env?: Env): Promise<T>;
export { post, get };
export default httpClient;
