import React from 'react';
import Icon from '../icon';
import './index.less';
var TreeNode = function TreeNode(props) {
  var _props$isLeaf = props.isLeaf,
    isLeaf = _props$isLeaf === void 0 ? false : _props$isLeaf,
    name = props.name;
  // 根据是否叶子节点来渲染对应的icon
  var renderIcon = function renderIcon(isLeaf) {
    if (!isLeaf) {
      return /*#__PURE__*/React.createElement(Icon, {
        type: "icon-bumen"
      });
    }
    return /*#__PURE__*/React.createElement(Icon, {
      type: "icon-yuangong"
    });
  };
  return /*#__PURE__*/React.createElement("span", {
    className: "tree-node"
  }, renderIcon(isLeaf), /*#__PURE__*/React.createElement("span", {
    className: "tree-node-name"
  }, name));
};
export default TreeNode;