"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _api = require("../api");
var _httpClient = require("../utils/httpClient");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var EmployeetStore = /*#__PURE__*/function () {
  function EmployeetStore() {
    _classCallCheck(this, EmployeetStore);
  }
  _createClass(EmployeetStore, [{
    key: "getSearchResultByname",
    value: function getSearchResultByname(name, env) {
      return (0, _httpClient.post)(_api.employeeMap.get('SEARCH'), {
        name: name
      }, env);
    }
  }, {
    key: "getEmployeeOrdepartmentTree",
    value: function getEmployeeOrdepartmentTree(env) {
      return (0, _httpClient.get)(_api.employeeMap.get('TREE'), {}, env);
    }
  }, {
    key: "getSearchEmployeeByNameAndPhoneAndEmial",
    value: function getSearchEmployeeByNameAndPhoneAndEmial(condition, env) {
      return (0, _httpClient.post)(_api.employeeMap.get('CONDITION'), {
        condition: condition,
        customerType: 2
      }, env);
    }
  }]);
  return EmployeetStore;
}();
var _default = new EmployeetStore();
exports.default = _default;